function [InfDS,negloglik,Xh_ekf2, P_ekf2, Xh_pred2, PPred2, inov2, Finv2, Py2, chiX2,tp, xk12,xk22,Jx2,kepti] = ekfContinuous4(InfDS,isb)%,Xh_ekf, P_ekf, Xh_pred, PPred
%xk12,xk22,xk32,xk42 x plus increment in RK4(2)

%if isb>=2 && InfDS.N~=1
%    disp('ERROR: InfDS.N~=1 when isb>=2!!')
%end


negloglik=0;kepti=0;
tspan = InfDS.tspan;


xk1 = zeros(InfDS.Nx,InfDS.Nsubj*InfDS.N, length(tspan));
xk2 = zeros(InfDS.Nx,InfDS.Nsubj*InfDS.N, length(tspan));

SigmaEta = InfDS.G*InfDS.SigmaEta*InfDS.G';
%if ~isempty(InfDS.pNoiseadaptParams)
%    SigmaEta = diag(max(InfDS.pNoiseadaptParams(1) * diag(InfDS.SigmaEta) , InfDS.pNoiseadaptParams(2)));
%end

PSigmaEta = reshape(SigmaEta,InfDS.Nx^2,1);

indext = 1:InfDS.totalT;

%if isb<=1
    tp = zeros(InfDS.Nsubj*InfDS.N,1);
    Xh_ekf = zeros(InfDS.Nx, InfDS.Nsubj*InfDS.N,length(tspan));
    Xh_pred = zeros(InfDS.Nx, InfDS.Nsubj*InfDS.N,length(tspan));
    P_ekf = zeros(InfDS.Nx, InfDS.Nx, InfDS.Nsubj*InfDS.N,length(tspan));
    PPred = zeros(InfDS.Nx, InfDS.Nx,InfDS.Nsubj*InfDS.N,length(tspan));
    Jx = zeros(InfDS.Nx, InfDS.Nx,InfDS.Nsubj*InfDS.N,length(tspan));
    Pprev = zeros(InfDS.Nx, InfDS.Nx,InfDS.Nsubj*InfDS.N);
    yPred = zeros(InfDS.Ny,InfDS.Nsubj*InfDS.N,length(tspan));
    inov = zeros(InfDS.Ny,InfDS.Nsubj*InfDS.N,length(tspan));
    Py =zeros(InfDS.Ny, InfDS.Ny,InfDS.Nsubj*InfDS.N,length(tspan));
    Finv =zeros(InfDS.Ny, InfDS.Ny,InfDS.Nsubj*InfDS.N,length(tspan));
    chiX = zeros(InfDS.Nsubj*InfDS.N,length(tspan));
    oldb = InfDS.b;
    
    if isb==1;
        InfDS.b = InfDS.bTemp;
    end
    
    
    Xh_pred(:,:,1) = feval(InfDS.odefn, InfDS.y0',0,InfDS,{},kron(repmat(tspan(1),1,InfDS.Nsubj),ones(1,InfDS.N)), ones(InfDS.Nsubj*InfDS.N));

    %kron(InfDS.y0',ones(1,InfDS.N));
    xk1(:,:,1)=Xh_pred(:,:,1);
    k1 = feval(InfDS.Jdyn, Xh_pred(:,:,1),InfDS,{},kron(repmat(tspan(1),1,InfDS.Nsubj),ones(1,InfDS.N)),...
         ones(InfDS.Nsubj*InfDS.N));
    %xk2(:,:,1) = Xh_pred(:,:,1)+InfDS.delt*xk1(:,:,1);
    %k2 = feval(InfDS.Jdyn, xk2(:,:,1),InfDS,{},kron(repmat(tspan(1)+InfDS.delt,1,InfDS.Nsubj),ones(1,InfDS.N)),...
    %     ones(InfDS.Nsubj*InfDS.N));
    %Jx(:,:,:,1) = reshape(repmat(eye(InfDS.Nx),1,InfDS.Nsubj*InfDS.N),InfDS.Nx, InfDS.Nx,InfDS.Nsubj*InfDS.N) + ...
    %    reshape(InfDS.delt/2*(k1 + k2),InfDS.Nx,InfDS.Nx,InfDS.Nsubj*InfDS.N);
    Jx(:,:,:,1) = reshape(k1,InfDS.Nx,InfDS.Nx,InfDS.Nsubj*InfDS.N);
 
     
    xprev = Xh_pred(:,:,1);
    Pprev(:,:,:,1) = reshape(repmat(InfDS.P0,1,InfDS.Nsubj*InfDS.N),InfDS.Nx,InfDS.Nx,InfDS.N*InfDS.Nsubj,1);
    
    
    for i=1:InfDS.Nsubj
        for q=1:InfDS.N
            %PPred(:,:,q+(i-1)*InfDS.N,1) = InfDS.delt^6*(SigmaEta)+ Jx(:,:,(q+(i-1)*InfDS.N))*Pprev(:,:,q+(i-1)*InfDS.N,1)*Jx(:,:,q+(i-1)*InfDS.N)';
            PPred(:,:,q+(i-1)*InfDS.N,1) = (SigmaEta)+ Jx(:,:,(q+(i-1)*InfDS.N))*Pprev(:,:,q+(i-1)*InfDS.N,1)*Jx(:,:,q+(i-1)*InfDS.N)';

        end
    end
    
%end

indexNA = 1:InfDS.Nx^2;
indexNA2 = 1:InfDS.Nx;
%badID = [];
%badt = [];
%badt2 = [];
%ft=[ InfDS.delt,InfDS.fulldt{i}];
ft=repmat(InfDS.delt,length(tspan),1);


for tt=1:length(tspan)
    
    %if isb<=1
        [yPred(:,:,tt), Jy] = feval(InfDS.yfun, Xh_pred(:,:,tt), InfDS); % yhat and Jacobian for hfun.
    %end
    
    
    for i=1:InfDS.Nsubj
        
        for q=1:InfDS.N
            
            currentt = indext(InfDS.timeDiscrete{i}==tspan(tt));
            if ~isempty(currentt)
                aa= min(reshape(isnan(InfDS.Y{i}(:,currentt)),InfDS.Ny,1));
            else
                aa= 1;
            end
            
            %if isb <=2% isb<=1
                if tt > 1
                    PPred(:,:,q+(i-1)*InfDS.N,tt) = Jx(:,:,q+(i-1)*InfDS.N,tt)*Pprev(:,:,q+(i-1)*InfDS.N)*Jx(:,:,q+(i-1)*InfDS.N,tt)'+InfDS.delt^6*(SigmaEta);
                end
                
                
                
                obsind=min(abs(InfDS.tobs{i}-tt)) ==0 && aa ==0;
                
                if obsind
                    indexY = 1:InfDS.Ny;
                    indexY = indexY(~isnan(InfDS.Y{i}(:,currentt)));
                    Ny = length(indexY);
                    
                    Py(indexY,indexY,q+(i-1)*InfDS.N,tt) = InfDS.Sigmae(indexY,indexY) + Jy(indexY,:,q+(i-1)*InfDS.N)*PPred(:,:,q+(i-1)*InfDS.N,tt)*Jy(indexY,:,q+(i-1)*InfDS.N)'; % Innovations covariance.
                    
                    inov(indexY,q+(i-1)*InfDS.N,tt) = InfDS.Y{i}(indexY,currentt)-yPred(indexY,q+(i-1)*InfDS.N,tt);
                    
                    [R,flag] = chol(Py(indexY,indexY,q+(i-1)*InfDS.N,tt));
                    if flag > 0 | max(diag(PPred(:,:,q+(i-1)*InfDS.N,tt))) > 100 | max(isnan(reshape(PPred(:,:,q+(i-1)*InfDS.N,tt),InfDS.Nx^2,1)))==1 | max(abs(Xh_pred(:,q+(i-1)*InfDS.N,tt))) > 100
                        Finv(indexY,indexY,q+(i-1)*InfDS.N,tt) = zeros(Ny,Ny);
                        K = zeros(InfDS.Nx,Ny);
                        chiX(q+(i-1)*InfDS.N,tt) = 0;
                        lik = 0;
                    else
                        
                        Finv(indexY,indexY,q+(i-1)*InfDS.N,tt) = inv(Py(indexY,indexY,q+(i-1)*InfDS.N,tt));
                        K = PPred(:,:,q+(i-1)*InfDS.N,tt)*Jy(indexY,:,q+(i-1)*InfDS.N)'*Finv(indexY,indexY,q+(i-1)*InfDS.N,tt);                      % Kalman gain.
                        chiX(q+(i-1)*InfDS.N,tt) = .5*(log(det(Py(indexY,indexY,q+(i-1)*InfDS.N,tt)))+inov(indexY,q+(i-1)*InfDS.N,tt)'*Finv(indexY,indexY,q+(i-1)*InfDS.N,tt)*inov(indexY,q+(i-1)*InfDS.N,tt));
                        lik = .5*InfDS.Ny*log(2*pi)+chiX(q+(i-1)*InfDS.N,tt);
                        
                    end
    
                    Ptemp = PPred(:,:,q+(i-1)*InfDS.N,tt) - K*Jy(indexY,:,q+(i-1)*InfDS.N)*PPred(:,:,q+(i-1)*InfDS.N,tt);
                    xtemp = Xh_pred(:,q+(i-1)*InfDS.N,tt)+K*(inov(indexY,q+(i-1)*InfDS.N,tt)) ;
                    
                    if (~isinf(lik)&&~isnan(lik))
                        negloglik=negloglik+lik;
                    end
                      %Catch non-sensible values
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                  
                    indexNAt = indexNA(isnan(reshape(Ptemp,InfDS.Nx^2,1)));
                    indexNA2t = indexNA2(isnan(xtemp));
                    indexNAtP = indexNA(isnan(reshape(PPred(:,:,q+(i-1)*InfDS.N,tt),InfDS.Nx^2,1)));
                    
                    
                    if ~isempty(indexNAt)
                        Ptemp = reshape(Ptemp,InfDS.Nx^2,1);
                        Ptemp2 = reshape(PPred(:,:,q+(i-1)*InfDS.N,tt),InfDS.Nx^2,1);
                        Ptemp2(indexNAtP) = PSigmaEta(indexNAtP);
                        Ptemp(indexNAt) = Ptemp2(indexNAt);
                        Ptemp = reshape(Ptemp,InfDS.Nx, InfDS.Nx);
                        Ptemp2 = reshape(Ptemp2,InfDS.Nx, InfDS.Nx);
                        PPred(:,:,q+(i-1)*InfDS.N,tt) = Ptemp2;
                    end
                                        
                    if ~isempty(indexNA2t)
                        xtemp(indexNA2t) = Xh_pred(indexNA2t,q+(i-1)*InfDS.N,tt);
                    end
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                   
                else
                    xtemp = Xh_pred(:,q+(i-1)*InfDS.N,tt);
                    Ptemp = PPred(:,:,q+(i-1)*InfDS.N,tt);
                end    %end of obsind
                    
                    Xh_ekf(:,q+(i-1)*InfDS.N,tt) = xtemp;
                    P_ekf(:,:,q+(i-1)*InfDS.N,tt) = Ptemp;
                    xprev(:,q+(i-1)*InfDS.N) = Xh_ekf(:,q+(i-1)*InfDS.N,tt);
                    Pprev(:,:,q+(i-1)*InfDS.N) = P_ekf(:,:,q+(i-1)*InfDS.N,tt);
      
        end% loop through InfDS.N
    end
    
    
    
    %R = (InfDS.timeDiscrete{i}(tt+1)-InfDS.timeDiscrete{i}(tt))/InfDS.delt;
    %for t=1:R
    k11 = xprev;
    k1 = feval(InfDS.odefn, k11,0,InfDS,{},kron(repmat(tspan(tt),1,InfDS.Nsubj),ones(1,InfDS.N)), zeros(InfDS.Nsubj*InfDS.N));
    k21= xprev+InfDS.delt*k1;
    k2 = feval(InfDS.odefn, k21,0,InfDS,{},kron(repmat(tspan(tt)+InfDS.delt,1,InfDS.Nsubj),ones(1,InfDS.N)),zeros(InfDS.Nsubj*InfDS.N));
     
    if tt < length(tspan)
        xprev = xprev + ft(tt+1)/2*(k1 + k2);
        Xh_pred(:,:,tt+1) = xprev;
        
            k1 = feval(InfDS.Jdyn, k11,InfDS,{},kron(repmat(tspan(tt),1,InfDS.Nsubj),ones(1,InfDS.N)), zeros(InfDS.Nsubj*InfDS.N));
            k2 = feval(InfDS.Jdyn, k21,InfDS,{},kron(repmat(tspan(tt)+ft(tt+1),1,InfDS.Nsubj),ones(1,InfDS.N)), zeros(InfDS.Nsubj*InfDS.N));
            Jx(:,:,:,tt+1) = reshape(repmat(eye(InfDS.Nx),1,InfDS.Nsubj*InfDS.N),InfDS.Nx, InfDS.Nx,InfDS.Nsubj*InfDS.N) + reshape(ft(tt+1)/2*(k1 + k2),InfDS.Nx,InfDS.Nx,InfDS.Nsubj*InfDS.N);
        
        xk1(:,:,tt+1) = k11;
        xk2(:,:,tt+1) = k21;
    end
    
end %length of loop through tt


%Not drawing anything, just want whole tspan length from ekf
Xh_ekf2 = Xh_ekf(:,1:InfDS.Nsubj,:);
Xh_pred2 = Xh_pred(:,1:InfDS.Nsubj,:);
inov2 = inov(:,1:InfDS.Nsubj,:);
PPred2 = PPred(:,:,1:InfDS.Nsubj,:);
Jx2 = Jx(:,:,1:InfDS.Nsubj,:);
P_ekf2 = P_ekf(:,:,1:InfDS.Nsubj,:);
Py2 = Py(:,:,1:InfDS.Nsubj,:);
Finv2 = Finv(:,:,1:InfDS.Nsubj,:);
xk12 = xk1(:,1:InfDS.Nsubj,:);
xk22 = xk2(:,1:InfDS.Nsubj,:);
chiX2 = sum(-1*chiX,2);
    
if isb == 1  %Drawing b    
    chiX3 = sum(-1*chiX,2);    
    index = 1:InfDS.N;
    InfDS.b = oldb;
    kepti = ones(InfDS.Nsubj,1);
    
    for i=1:InfDS.Nsubj  
        chiXi = chiX3((1+(i-1)*InfDS.N):(i*InfDS.N));
            mchi = chiXi(~isnan(chiXi));
            mchi = max(mchi);
            
            
            if isnan(mchi)==0
                toChoose = index(~isnan(chiXi) & chiXi == max(chiXi));
                if length(toChoose) > 1, toChoose = toChoose(1);
                end
                kepti(i) = toChoose;
                InfDS.b(i,:) = InfDS.bTemp(kepti(i)+(i-1)*InfDS.N,:);
            else
                kepti(i) = NaN;
            end
      if (~isnan(kepti(i))) && max(isnan(Xh_ekf(1,kepti(i)+(i-1)*InfDS.N,:))==0)
            chiX2 = chiX(kepti(i)+(i-1)*InfDS.N,:);
     end        
            
    end
    chiX2 = sum(-1*chiX2,2);   
    
elseif isb == -2 %Not drawing b, but just don't want the whole tspan series  
Xh_ekf2 = zeros(InfDS.Nx, InfDS.Nsubj,InfDS.totalT);
Xh_pred2 = zeros(InfDS.Nx, InfDS.Nsubj,InfDS.totalT);
P_ekf2 = zeros(InfDS.Nx, InfDS.Nx, InfDS.Nsubj,InfDS.totalT);
PPred2 = zeros(InfDS.Nx, InfDS.Nx,InfDS.Nsubj,InfDS.totalT);
Jx2 = zeros(InfDS.Nx, InfDS.Nx,InfDS.Nsubj,InfDS.totalT);
inov2 = zeros(InfDS.Ny,InfDS.Nsubj,InfDS.totalT);
Py2 =zeros(InfDS.Ny,InfDS.Ny, InfDS.Nsubj,InfDS.totalT);
Finv2 =zeros(InfDS.Ny, InfDS.Ny,InfDS.Nsubj,InfDS.totalT);
    
for i=1:InfDS.Nsubj
Xh_ekf2(:,i,1:InfDS.allT(i)) = Xh_ekf(:,i,InfDS.tobs{i});
Xh_pred2(:,i,1:InfDS.allT(i)) = Xh_pred(:,i,InfDS.tobs{i});
inov2(:,i,1:InfDS.allT(i)) = inov(:,i,InfDS.tobs{i});
PPred2(:,:,i,1:InfDS.allT(i)) = PPred(:,:,i,InfDS.tobs{i});
Jx2(:,:,i,1:InfDS.allT(i)) = Jx(:,:,i,InfDS.tobs{i});
P_ekf2(:,:,i,1:InfDS.allT(i)) = P_ekf(:,:,i,InfDS.tobs{i});
Py2(:,:,i,1:InfDS.allT(i)) = Py(:,:,i,InfDS.tobs{i});
Finv2(:,:,i,1:InfDS.allT(i)) = Finv(:,:,i,InfDS.tobs{i});
xk12(:,i,1:InfDS.allT(i)) = xk1(:,i,InfDS.tobs{i});
xk22(:,i,1:InfDS.allT(i)) = xk2(:,i,InfDS.tobs{i});
end

end
    
if InfDS.Nb > 0
        tp = -0.5*(diag(InfDS.b/InfDS.Sigmab*InfDS.b')+repmat(log(det(InfDS.Sigmab)),InfDS.Nsubj,1))+ chiX2;
end 
  


end