function [InfDS, stop, stage, gmm,ss,sgnTH,redFlag,ssmin,noIncrease,convFlag] = saem(InfDS,gmm,stage,sgnTH,mscore,mscore2,minfoMat,Covscore,ssmin,noIncrease) 
%redflag=1 if I is not postive definite
ss=-1;
stop = 0;
%errtrol1 = 1/sqrt(InfDS.KKO);%1/100;

thetam = reshape(InfDS.par,length(InfDS.par),1);
convFlag = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Gain constant for stage 1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    gainpara = InfDS.gainpara;
    gainparb = InfDS.gainparb;
 
    
if stage==2, 
    gainpara = InfDS.gainpara1; 
    gainparb = InfDS.gainparb1;
end;

if stage < 2 && gmm <= 5
	gmm1=1;
%elseif stage== 1 && gmm > 10
%	gmm1=gmm-10;
else
    gmm1 = gmm;
%else
%    gmm1 = gmm-5;
end

gain = gainparb/(gmm1^gainpara + gainparb - 1);   
%gain = gainparb/(gmm^gainpara + gainparb - 1);   
%gain=1;


redFlag=0; sy = InfDS.sy; ES = InfDS.ES; EI = InfDS.EI; Iy = InfDS.Iy;
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%"M"-step
%Here ss is a multiplicative constant (t in Zhu et al.) to make sure that the
%information matrix is positive definite.   
 
 InfDS.sy = InfDS.sy + gain*(mscore-InfDS.sy);
 InfDS.ES = InfDS.ES + gain*(mscore2-InfDS.ES);
 InfDS.EI = InfDS.EI + gain*(minfoMat-InfDS.EI);
 t=1.0;
 InfDS.Iy = - t*InfDS.ES + (InfDS.sy*InfDS.sy') + InfDS.EI;
 
% disp(InfDS.EI);
% disp(InfDS.ES);
% disp(InfDS.sy);
 
 
[R,flag] = chol(InfDS.Iy);
%if gain < .8&& flag > 0
    while (flag>0 &&  t >=.4)
    t=0.5*t;
    InfDS.Iy = - t*InfDS.ES + (InfDS.sy*InfDS.sy') + InfDS.EI;
    [R,flag] = chol(InfDS.Iy);
    %if (flag) > 0
    %fprintf('\nIy is not positive definite. ss = %5f\n',ss);
    %fprintf('Serious error!\n');
    %end
    end
%end

 
%if nargin > 8
%InfDS2.sy = InfDS2.sy + gain*(mscore0-InfDS2.sy);
%InfDS2.ES = InfDS2.ES + gain*(mscore20-InfDS2.ES);
%InfDS2.EI = InfDS2.EI + gain*(minfoMat0-InfDS2.EI);   
%InfDS2.Iy = InfDS2.EI - InfDS2.ES + (InfDS2.sy*InfDS2.sy');
%[R2,flag2] = chol(InfDS2.Iy);
%if gain < .8&& flag2 > 0
%    while (flag>0 &&  t2 >=.4)
%    t2=0.5*t2;
%    InfDS2.Iy = InfDS2.EI - t2*InfDS2.ES + (InfDS2.sy*InfDS2.sy');
%    [R2,flag] = chol(InfDS2.Iy);
%    end;
%end
%end

%%

 [R,flag] = chol(InfDS.Iy);
 if flag~= 0
     redFlag=1;
 end

 %disp(InfDS.Iy);
 %disp(mscore);
  
dc2 = (InfDS.Iy\mscore);    



%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~redFlag 
thetam = thetam + gain*dc2;
end

if stage > 0 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Stopping rule for stage 1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dc2(abs(dc2) < .0001) = 0;
    if stage==1 
    sgnTH(:,gmm) = gain*sign(dc2); 
    if gmm >= InfDS.KKO      
       ss = norm(mean(sgnTH(:,(gmm-InfDS.KKO+1):gmm),2));%norm(sum(sgnTH(:,gmm-InfDS.KKO+1:gmm),2));
       fprintf('\nStage 1 Error tolerance at convergence = %6f\n',ss); 
       %if (ss<=1/InfDS.errtrol1||gmm==InfDS.maxIterStage1),
	    if (ss<=InfDS.errtrol1||gmm==InfDS.maxIterStage1),
        stage=2; gmm=1;
        %Initiate off-line estimates at i = K1
        %if nargin > 8
        %InfDS2.sytild = InfDS2.sy;
        %InfDS2.EStild = InfDS2.ES;
        %InfDS2.EItild = InfDS2.EI;
        %InfDS2.Iytild = InfDS2.Iy;
        %end
      end;
    end
    end; %end of if stage==1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



for q=1:length(InfDS.par)
   if ~isnan(InfDS.lowBound(q))
       if (thetam(q) < InfDS.lowBound(q) || thetam(q) > InfDS.upBound(q))
       thetam(q) = InfDS.par(q);%InfDS.lowBound(q) + .1;
       redFlag=1;
       InfDS.sy(q) = sy(q);
       InfDS.ES(q,q) = ES(q,q);
       InfDS.EI(q,q) = EI(q,q);
       InfDS.Iy (q,q) = Iy(q,q); 
       end
   end
  if isnan(thetam(q))
       thetam(q) = InfDS.par(q);
       redFlag=1;
       InfDS.sy(q) = sy(q);
       InfDS.ES(q,q) = ES(q,q);
       InfDS.EI(q,q) = EI(q,q);
       InfDS.Iy(q,q) = Iy(q,q);  
   end
end

if ((~any(any(any(isnan(InfDS.Xtild))))==0 || redFlag==1) && InfDS.Nbeta > 0)
    thetam(1:InfDS.Nbeta) = InfDS.par(1:InfDS.Nbeta);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Off-line averaging procedure
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if stage==2 
    if max(InfDS.thetatild)==0 && min(InfDS.thetatild)==0
        InfDS.sytild = InfDS.sy; 
        InfDS.EStild = InfDS.ES; 
        InfDS.EItild = InfDS.EI;
        InfDS.Iytild = InfDS.Iy;
        InfDS.thetatild = thetam;
    else
   InfDS.sytild = InfDS.sytild + (InfDS.sy-InfDS.sytild)/gmm;
   InfDS.EStild = InfDS.EStild + (InfDS.ES-InfDS.EStild)/gmm;
   InfDS.EItild = InfDS.EItild + (InfDS.EI-InfDS.EItild)/gmm;
   InfDS.Iytild = InfDS.Iytild + (InfDS.Iy-InfDS.Iytild)/gmm;
   InfDS.thetatild = InfDS.thetatild + (thetam-InfDS.thetatild)/gmm;
%           if nargin > 8
%   InfDS2.sytild = InfDS2.sytild + (InfDS2.sy-InfDS2.sytild)/gmm;
%   InfDS2.EStild = InfDS2.EStild + (InfDS2.ES-InfDS2.EStild)/gmm;
%   InfDS2.EItild = InfDS2.EItild + (InfDS2.EI-InfDS2.EItild)/gmm;
%   InfDS2.Iytild = InfDS2.Iytild + (InfDS2.Iy-InfDS2.Iytild)/gmm;  
%           end
   ss = abs(InfDS.sytild'/InfDS.Iytild*InfDS.sytild + trace(InfDS.Iytild\Covscore)/gmm);
   if (ss > ssmin)
       noIncrease = noIncrease + 1;
   else
       ssmin = ss;
       noIncrease = 0;
   end
   %ss3 = trace(InfDS.Iytild\Covscore)/gmm;
   %ss4 = InfDS.sytild'/InfDS.Iytild*InfDS.sytild;
   %ss5 = InfDS.sytild((InfDS.Nbeta+1):length(InfDS.par))'/InfDS.Iytild((InfDS.Nbeta+1):length(InfDS.par),(InfDS.Nbeta+1):length(InfDS.par))*InfDS.sytild((InfDS.Nbeta+1):length(InfDS.par));   
   %ss6 = (InfDS.sytild(1:InfDS.Nbeta)'/(InfDS.Iytild(1:InfDS.Nbeta,1:InfDS.Nbeta))*InfDS.sytild(1:InfDS.Nbeta));   
   %ss = ss3 + ss5 + ss6;
        fprintf('\nStage 2 ss = %6f\n',ss);
        %fprintf('\nss3 = %6f\n',ss3);
        %fprintf('\nss4 = %6f\n',ss4);
        %fprintf('\nss5 = %6f\n',ss5);        
   
   if ss < InfDS.errtrol || gmm == InfDS.MAXITER || noIncrease > 3%-InfDS.maxIterStage1;
        if gmm==InfDS.MAXITER || noIncrease > 3
            convFlag=0;
        else convFlag=1;
        end
       stop=1;
   end;
    end
end;
end %End of if stage > 0 and ~redFlag


gmm = gmm+1;

InfDS.par = thetam;



end
   
   
