function r = dfdparFixedIC(xin,InfDS,i,t)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% The van der Pol oscillator equations in vector form
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

y = xin;


if size(y,2) > 1
r = zeros(InfDS.Ntheta,InfDS.NxState,size(y,2));
else
r = zeros(InfDS.Ntheta,InfDS.NxState);
end

%par = InfDS.par(1:InfDS.Nbeta);

%if ~isempty(i)
%pari = kron(ones(1,size(y,2)),InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:)*reshape(par(1:InfDS.Nbeta),InfDS.Nbeta,1));    
%else
%pari = kron(reshape(InfDS.H*reshape(par(1:InfDS.Nbeta),InfDS.Nbeta,1),InfDS.Ntheta,InfDS.Nsubj),ones(1,InfDS.N));    
%end


%size(pari)


%b = zeros(size(pari));
%if (InfDS.Nb > 0)
%if ~isempty(i) %Only for one subject, but may have t > 1
%b(1:InfDS.Ntheta,:) = kron(ones(1,size(y,2)),InfDS.Z*reshape(InfDS.b(i,:),InfDS.Nb,1));    
%elseif mod(size(y,2),InfDS.Nsubj)==0 %for more than one subject but one t
%b = InfDS.Z*InfDS.b';    
%else %for more than one subject and more than one t
%   bb = InfDS.Z*InfDS.b';    
%   bb = kron(bb,ones(1,max(InfDS.allT)));
%   b = bb(:,InfDS.Tfilter==1);        
%end
%end

%pari = pari+b;


%df/dpar
%row-theta, column, f


if size(y,2) > 1
r(1,2,:) =  -y(2,:).*(y(1,:).^2 - 1);    

else %if scalar
r(1,2) =  -y(2)*(y(1)^2 - 1);

end

end


