function [InfDS] = PropSigb(InfDS)

Sigmae = InfDS.Sigmae;
iSigmae= eye(size(Sigmae)) / Sigmae;

%dxstardthetafAll = InfDS.dXstarAll; 
dXtilddthetafAll = InfDS.dXtildthetafAll;


for i=1:InfDS.Nsubj
    
    T = length(InfDS.timeDiscrete{i});%(InfDS.lens(i));
    
    temp = zeros(size(InfDS.Sigmab));
    %dt = InfDS.Deltat{i};%InfDS.fulldt{i};
    for t=1:(T-1)%No last time point
                dfdbt = InfDS.Z'*dXtilddthetafAll{i}(:,(1+(t-1)*InfDS.NxState):(t*InfDS.NxState))*InfDS.Lambda';
                temp = temp+dfdbt*iSigmae*dfdbt'; 
    end %end of t loop
        
    OMEGAb(1+(i-1)*InfDS.Nb:i*InfDS.Nb,1+(i-1)*InfDS.Nb:i*InfDS.Nb) = inv(inv(InfDS.Sigmab) + temp);    
end

InfDS.OMEGAb = OMEGAb;

end