function [tp] = ekfContinuous10(InfDS)%,Xh_ekf, P_ekf, Xh_pred, PPred
%xk12,xk22,xk32,xk42 x plus increment in RK4(2)

tp = zeros(InfDS.Nsubj*InfDS.N,1);
chiYX = zeros(InfDS.Nsubj,InfDS.totalT-1);

Sigmae = InfDS.Sigmae;
iSigmae= eye(size(Sigmae)) / Sigmae;

for tt=1:InfDS.totalT
    %need a vectorize version
    for i=1:InfDS.Nsubj 
        if tt <= InfDS.allT(i)
        indexY = 1:InfDS.Ny;
        indexY = indexY(~isnan(InfDS.Y{i}(:,tt)));
		
		%InfDS.Xtild = zeros(InfDS.Nx,InfDS.Nsubj,InfDS.totalT);    		
        [yPredtmp, Jytmp] = feval(InfDS.yfun, InfDS.Xtild(:,i,tt), InfDS); % yhat and Jacobian for hfun.
        inovtmp = InfDS.Y{i}(indexY,tt)-yPredtmp(indexY);                   		
		chiYX(i,tt) = inovtmp'*iSigmae(indexY,indexY)*inovtmp;
        end
    end
end %length of loop through tt

if InfDS.Nb > 0
    tp = -0.5*(sum((InfDS.b/InfDS.Sigmab).*InfDS.b,2) + sum(chiYX,2));
end


end