%function [score,infoMat] =  getScoreInfoInov2(Xh_ekf, Xh_pred, P_ekf, xk1,xk2,xk3,xk4, InfDS,dxstardthetafAll,dxstardthetafAll2,isInfo,isDivideN,isDivideT)
function [score,infoMat,InfDS] =  getScoreInfoY_tobs_opt(InfDS,stage,iter,freeIC)

SIndex = reshape(1:InfDS.Ny^2,InfDS.Ny,InfDS.Ny);
SIndex2 = reshape(1:(InfDS.Ny^2*InfDS.Ny),InfDS.Ny,InfDS.Ny^2);

LIndex = reshape(1:(InfDS.Nx*InfDS.Ny),InfDS.Ny,InfDS.Nx);


if InfDS.Nbeta > 0
    dlikdBetaAll = zeros(InfDS.Nbeta,1);
    dlikdBetaAll2 = zeros(InfDS.Nbeta,InfDS.Nbeta);
end

if InfDS.Nmu > 0
    dlikdmuAll = zeros(InfDS.Nmu,1);
    dlikdmuAll2 = zeros(InfDS.Nmu,InfDS.Nmu);
end

if InfDS.NLambda > 0
    dlikdLambdaAll = zeros(InfDS.NLambda,1);
    dlikdLambdaAll2 = zeros(InfDS.NLambda,InfDS.NLambda);
end

%qqqqq
if InfDS.Nmu > 0 && InfDS.NLambda > 0
  dlikdMudLambda = zeros(InfDS.Nmu,InfDS.NLambda); %qqqqq
  dlikdLambdMu = zeros(InfDS.NLambda, InfDS.Nmu);
end
if InfDS.Nbeta > 0 && InfDS.NLambda > 0
  dlikdMudBeta = zeros(InfDS.Nmu,InfDS.Nbeta); %qqqqq
  dlikdBetadMu = zeros(InfDS.Nbeta, InfDS.Nmu);
end
if InfDS.Nbeta > 0 && InfDS.NLambda > 0
  dlikdLambdadBeta = zeros(InfDS.NLambda,InfDS.Nbeta); %qqqqq
  dlikdBetadLambda = zeros(InfDS.Nbeta, InfDS.NLambda);
end


dlikdEpsilonAll = zeros(InfDS.Ny,1);
dlikdEpsilonAll2 = zeros(InfDS.Ny,InfDS.Ny);

%if InfDS.Neta > 0
%    dlikdEtaAll = zeros(InfDS.Neta,1);
%    dlikdEtaAll2 = zeros(InfDS.Neta,InfDS.Neta);    
%end
if InfDS.Nb > 0
    dlikdbAll = zeros(InfDS.Nbpar,1);
    dlikdbAll2 = zeros(InfDS.Nbpar,InfDS.Nbpar);
    ivSigmab = inv(InfDS.Sigmab);
end


infoMat = zeros(length(InfDS.par),length(InfDS.par));
ivSigmae2 = diag(1./diag(InfDS.Sigmae));
%tspan = 0:InfDS.delt:InfDS.maxT;
%tspan = round2(tspan,InfDS.delt);

    if InfDS.Nbetax > 0
        Lambda = zeros(InfDS.Ny,InfDS.Nx);
        Lambda(:,1:InfDS.NxState) = InfDS.Lambda;
    else
        Lambda = InfDS.Lambda;
    end
    
if InfDS.Nbeta > 0    
InfDS = getXtildIC3(InfDS,1,freeIC); %Get updated Xtilde
else
InfDS = getXtildIC3(InfDS,0,freeIC); %Get updated Xtilde
end

mulp2 = 1;
    %if stage==1
    %    mulp2 = InfDS.Nsubj;
    %end
    
    
for i=1:InfDS.Nsubj
    T = InfDS.allT(i);%InfDS.allT(i)=length(InfDS.timeDiscrete{i}) only at observed
    %Deltati = InfDS.Deltat{i};%round2(InfDS.Deltat{i},InfDS.delt);    
    %dt=InfDS.Deltat{i};%InfDS.fulldt{i};
    X = InfDS.Xtild(:,i,1:T);
    
    
    mulp = 1; %mulpBeta = 1;
%if stage==1 && iter < InfDS.KKO
    %mulpBeta = InfDS.allT(i);
%end
    
    

    Z = InfDS.Y{i}(:,1:T) - (kron(ones(1,T),InfDS.mu) + Lambda*reshape(X,InfDS.Nx,T));
    
    for t=1:T

        Zt = Z(:,t);
        indexY = 1:InfDS.Ny;
        Ny = length(InfDS.Y{i}(~isnan(InfDS.Y{i}(:,t))&~isinf(Zt)&~isnan(Zt),t));
        indexY = indexY(~isnan(InfDS.Y{i}(:,t))&~isinf(Zt)&~isnan(Zt));
        if (~isempty(indexY) && length(InfDS.Y{i}(isnan(InfDS.Y{i}(:,t)),t)) < InfDS.Ny)%Not all indicators are missing

           if (InfDS.Nbeta > 0)% > 0
                dXtildthetaf = InfDS.dXtildthetafAll{i};
                dXtildthetaf2 = InfDS.dXtildthetafAll2{i};
               
               dlik = (InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:)'*dXtildthetaf(:,(1+(t-1)*InfDS.Nx):(t*InfDS.Nx)))*Lambda(indexY,:)'*ivSigmae2(indexY,indexY)*Zt(indexY);
                vvv=kron(eye(InfDS.Nx),InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:)');
                dlik2 = kron(Zt(indexY)'*ivSigmae2(indexY,indexY)*Lambda(indexY,:),eye(InfDS.Nbeta))*vvv*dXtildthetaf2((1+(t-1)*InfDS.Ntheta*InfDS.Nx):(t*InfDS.Ntheta*InfDS.Nx),:)*InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:)-...
                InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:)'*dXtildthetaf(:,(1+(t-1)*InfDS.Nx):(t*InfDS.Nx))*Lambda(indexY,:)'*ivSigmae2(indexY,indexY)*Lambda(indexY,:)*dXtildthetaf(:,(1+(t-1)*InfDS.Nx):(t*InfDS.Nx))'*InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:);
                dlikdBetaAll = dlikdBetaAll+ (~isnan(dlik)&~isinf(dlik)).*dlik/mulp;
                dlikdBetaAll2 = dlikdBetaAll2+ (~isnan(dlik2)&~isinf(dlik2)).*dlik2/mulp;
                if any(isnan(dlik))||any(any(isnan(dlik2)))
                    disp(i);
                    disp(t);
                    disp('is na \n');
                end
                if any(isinf(dlik))||any(any(isinf(dlik2)))
                    disp(i);
                    disp(t);
                    disp('is inf\n');
                end
           end %End of Nbeta > 0 loop            

aa =  reshape(1:InfDS.Ny^2,InfDS.Ny,InfDS.Ny); 
SIndex3 = reshape(aa(indexY,indexY),size(indexY,2)^2,1);


            if InfDS.Nmu > 0
                dlik = (InfDS.dmudparMu(indexY,indexY)*ivSigmae2(indexY,indexY)*Zt(indexY));
                dlik2 = (kron(Zt(indexY)'*ivSigmae2(indexY,indexY),eye(size(indexY,2)))*InfDS.dmudparMu2(SIndex3,indexY) - InfDS.dmudparMu(indexY,indexY)*ivSigmae2(indexY,indexY)*InfDS.dmudparMu(indexY,indexY)');
                dlikdmuAll(indexY) = dlikdmuAll(indexY) + dlik/mulp;
                dlikdmuAll2(indexY,indexY) = dlikdmuAll2(indexY,indexY)+  dlik2/mulp;
            end
            
            dlik = (.5*InfDS.dSigmaede(indexY,reshape(SIndex(indexY,indexY),1,Ny^2))*(kron(ivSigmae2(indexY,indexY),ivSigmae2(indexY,indexY))*reshape(Zt(indexY)*Zt(indexY)'-InfDS.Sigmae(indexY,indexY),Ny^2,1)));
            
            a = reshape(SIndex(indexY,indexY),1,Ny^2);
            dlik2 = (.5*kron(reshape(ivSigmae2(indexY,indexY)*(Zt(indexY)*Zt(indexY)')*ivSigmae2(indexY,indexY),1,Ny^2),eye(Ny))*InfDS.dSigmaede2(reshape(SIndex2(indexY,a),1,Ny*Ny^2),indexY)-InfDS.dSigmaede(indexY,reshape(SIndex(indexY,indexY),1,Ny^2))*(kron(ivSigmae2(indexY,indexY),ivSigmae2(indexY,indexY)*(Zt(indexY)*Zt(indexY)')*ivSigmae2(indexY,indexY)))*InfDS.dSigmaede(indexY,reshape(SIndex(indexY,indexY),1,Ny^2))'-.5*(kron(reshape(ivSigmae2(indexY,indexY),1,Ny^2),eye(Ny))*InfDS.dSigmaede2(reshape(SIndex2(indexY,a),1,Ny*Ny^2),indexY))+.5*(InfDS.dSigmaede(indexY,reshape(SIndex(indexY,indexY),1,Ny^2))*kron(ivSigmae2(indexY,indexY),ivSigmae2(indexY,indexY))*InfDS.dSigmaede(indexY,reshape(SIndex(indexY,indexY),1,Ny^2))'));
            
            
            dlikdEpsilonAll(indexY) = dlikdEpsilonAll(indexY)+ (~isnan(dlik)&~isinf(dlik)).*dlik/mulp;
            dlikdEpsilonAll2(indexY,indexY) = dlikdEpsilonAll2(indexY,indexY) + (~isnan(dlik2)&~isinf(dlik2)).*dlik2/mulp;
            
            
            if InfDS.NLambda > 0
                indexY2 = indexY(indexY>1);
                
                
                a = reshape(LIndex(indexY,:),1,Ny*InfDS.Nx);
                dlik = (InfDS.dLambdparLamb(indexY(indexY>1)-1,a)*reshape(ivSigmae2(indexY,indexY)*Zt(indexY)*X(:,t)',Ny*InfDS.Nx,1));
                dlik2 = (-InfDS.dLambdparLamb(indexY(indexY>1)-1,a)*(kron(X(:,t)*X(:,t)',ivSigmae2(indexY,indexY)))*InfDS.dLambdparLamb(indexY(indexY>1)-1,a)');
                
                %Don't need this part because InfDS.dLambdaparLambd2 = 0. If not, add it
                %back to dlik2
                %NLambda = length(indexY(indexY>1));
                %a2 = reshape(LIndex2(indexY2-1,:),1,Ny*InfDS.Nx*NLambda);
                %+kron(reshape(ivSigmae2(indexY,indexY)*Zt(indexY)*Xh_ekf(:,i,t)',1,Ny*InfDS.Nx),eye(NLambda))*InfDS.dLambdaparLambd2(a2,indexY2-1)
                
                
                dlikdLambdaAll(indexY2-1) =  dlikdLambdaAll(indexY2-1) + (~isnan(dlik)&~isinf(dlik)).*dlik/mulp;
                dlikdLambdaAll2((indexY2-1),(indexY2-1)) = dlikdLambdaAll2(indexY2-1,indexY2-1)+ (~isnan(dlik2)&~isinf(dlik2)).*dlik2/mulp;
                
            end

           
            %############# 7/5/13
            %if stage==2
            %    if InfDS.NLambda > 0 && InfDS.Nmu > 0  
            %    dlik2 = -InfDS.dmudparMu(indexY,indexY)*ivSigmae2(indexY,indexY)*kron(X(:,t)',eye(InfDS.Ny))*InfDS.dLambdparLamb(indexY(indexY>1)-1,a)';                
            %    dlikdMudLambda(indexY,indexY2-1) = dlikdMudLambda(indexY,indexY2-1)+(~isnan(dlik2)&~isinf(dlik2)).*dlik2/mulp;
            %    dlikdLambdMu((indexY2-1),indexY) = dlikdMudLambda(indexY,indexY2-1)';
            %    end
            %    if InfDS.Nbeta > 0 && InfDS.Nmu > 0  
            %    dlik2 =  -InfDS.dmudparMu(indexY,indexY)*ivSigmae2(indexY,indexY)*Lambda(indexY,:)*dXtildthetaf(:,(1+(t-1)*InfDS.Nx):(t*InfDS.Nx))'*InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:);                
            %    dlikdMudBeta(indexY,:) = dlikdMudBeta(indexY,:)+(~isnan(dlik2)&~isinf(dlik2)).*dlik2/mulp;
            %    dlikdBetadMu(:,indexY) = dlikdMudBeta(indexY,:)';
            %    end
            %    if InfDS.Nbeta > 0 && InfDS.NLambda > 0  
            %    dlik2 = InfDS.dLambdparLamb(indexY(indexY>1)-1,a)*(kron(eye(InfDS.Nx),ivSigmae2)*...
            %    (-kron(X(:,t)',eye(size(indexY,2)))'*(Lambda(indexY,:)*dXtildthetaf(:,(1+(t-1)*InfDS.Nx):(t*InfDS.Nx))'*InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:))+...
            %    kron(eye(InfDS.Nx),Zt)*dXtildthetaf(:,(1+(t-1)*InfDS.Nx):(t*InfDS.Nx))'*InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:))...
            %    );           
            %    dlikdLambdadBeta((indexY2-1),:) = dlikdLambdadBeta((indexY2-1),:)+(~isnan(dlik2)&~isinf(dlik2)).*dlik2/mulp;
            %    dlikdBetadLambda(:,(indexY2-1)) = dlikdLambdadBeta((indexY2-1),:)';
            %    end
            %end
            %############# 7/5/13   
            
            
        end %end of if then check if all Nys are missing at time t.
        
    end %end of t loop
    
    
     %Deltati = round2(InfDS.Deltat{i},InfDS.delt);
    

    
    if InfDS.Nb > 0
        b = reshape(InfDS.b(i,:),InfDS.Nb,1);
        dlik = (.5*InfDS.dSigmabdb*(kron(ivSigmab,ivSigmab)*reshape(b*b'-InfDS.Sigmab,InfDS.Nb^2,1)));
        dlik2 = (.5*kron(reshape(ivSigmab*b*b'*ivSigmab,1,InfDS.Nb^2),eye(InfDS.Nbpar))*InfDS.dSigmabdb2-InfDS.dSigmabdb*(kron(ivSigmab,ivSigmab*b*b'*ivSigmab))*InfDS.dSigmabdb'-.5*kron(reshape(ivSigmab,1,InfDS.Nb^2),eye(InfDS.Nbpar))*InfDS.dSigmabdb2+.5*InfDS.dSigmabdb*kron(ivSigmab,ivSigmab)*InfDS.dSigmabdb');
        
        dlikdbAll = dlikdbAll+ (~isnan(dlik)&~isinf(dlik)).*dlik/mulp2;
        dlikdbAll2 = dlikdbAll2+ (~isnan(dlik2)&~isinf(dlik2)).*dlik2/mulp2;
        
    end
    
    
end%end of subject loop

score=[];
curpos2 = 0;
if InfDS.Nbeta  > 0
    score = dlikdBetaAll;
    curpos1 = 1; curpos2 = curpos2+InfDS.Nbeta;
    infoMat(curpos1:curpos2,curpos1:curpos2) = dlikdBetaAll2;
    startBeta = curpos1; endBeta = curpos2;
end

if InfDS.Nmu > 0
    score = [score; dlikdmuAll];
    curpos1 = curpos2+1; curpos2 = curpos2+InfDS.Nmu;
    infoMat(curpos1:curpos2,curpos1:curpos2) = dlikdmuAll2;
    startMu = curpos1; endMu = curpos2;   
end

if InfDS.NLambda > 0
    score = [score; dlikdLambdaAll];
    curpos1 = curpos2+1; curpos2 = curpos2+InfDS.NLambda;
    infoMat(curpos1:curpos2,curpos1:curpos2)=dlikdLambdaAll2;
    startLamb = curpos1; endLamb = curpos2;  
end

%Measurement error variances
score = [score;dlikdEpsilonAll];
curpos1 = curpos2+1; curpos2 = curpos2+InfDS.Ny;
infoMat(curpos1:curpos2,curpos1:curpos2)=dlikdEpsilonAll2;


%if InfDS.Neta > 0
%    score = [score;dlikdEtaAll];
%    curpos1 = curpos2+1; curpos2 = curpos2+InfDS.Neta;
%    infoMat(curpos1:curpos2,curpos1:curpos2)=dlikdEtaAll2;
%end

if InfDS.Nb > 0
    score = [score; dlikdbAll];
    curpos1 = curpos2+1; curpos2 = curpos2+InfDS.Nbpar;
    infoMat(curpos1:curpos2,curpos1:curpos2) = dlikdbAll2;
end

if InfDS.Nmu > 0 && InfDS.NLambda > 0, 
     infoMat(startMu:endMu,startLamb:endLamb) = dlikdMudLambda;
     infoMat(startLamb:endLamb,startMu:endMu) = dlikdLambdMu;
end

if InfDS.Nmu > 0 && InfDS.Nbeta, 
     infoMat(startMu:endMu,startBeta:endBeta) = dlikdMudBeta;
     infoMat(startBeta:endBeta,startMu:endMu) = dlikdBetadMu;
end
if InfDS.NLambda > 0 && InfDS.Nbeta, 
     infoMat(startLamb:endLamb,startBeta:endBeta) = dlikdLambdadBeta;
     infoMat(startBeta:endBeta,startLamb:endLamb) = dlikdBetadLambda;
end
infoMat = -1*infoMat;

end

