function r = dfdx2FixedIC(xin,InfDS,i,t)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Evaluates dvec(df/dx)/dx
%dvecdfdXtilddXtild_2 = [0,0; %f1
%                        0,0;  %f2
%                        -2*Xtild2(2)*thetaf1, -2*Xtild2(1)*thetaf1; %f3
%                        -2*thetaf1*Xtild2(1), 0]; %f4  %Put this into dfdx2IC.m 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

y = xin;

%omega = InfDS.omega;



if size(y,2) > 1
r = zeros(InfDS.Nx^2,InfDS.Nx,size(y,2));
else
r = zeros(InfDS.Nx^2,InfDS.Nx);
end


par = InfDS.par(1:InfDS.Nbeta);
%par = InfDS.dynpar;


if ~isempty(i)
pari = kron(ones(1,size(y,2)),InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:)*reshape(par,InfDS.Nbeta,1));    
else
pari = kron(reshape(InfDS.H*reshape(par,InfDS.Nbeta,1),InfDS.Ntheta,InfDS.Nsubj),ones(1,InfDS.N));    
end



%size(pari)


b = zeros(size(pari));
if (InfDS.Nb > 0)
if ~isempty(i) %Only for one subject, but may have t > 1
b(1:InfDS.Ntheta,:) = kron(ones(1,size(y,2)),InfDS.Z*reshape(InfDS.b(i,:),InfDS.Nb,1));    
elseif mod(size(y,2),InfDS.Nsubj)==0 %for more than one subject but one t
b = InfDS.Z*InfDS.b'; 
%b = kron(reshape(b,InfDS.Nb,InfDS.Nsubj),ones(1,InfDS.N));    
else %for more than one subject and more than one t
   bb = InfDS.Z*InfDS.b';    
   bb = kron(bb,ones(1,max(InfDS.lens)));
   b = bb(:,InfDS.Tfilter==1);        
end
end


pari = pari+b;

%f in rows, x in columns
if size(y,2) > 1
    r(3,1,:) = -2*y(2,:).*pari(1,:);
    r(3,2,:) = -2*y(1,:).*pari(1,:);
    r(4,1,:) = -2*pari(1,:).*y(1,:);    
else
    r(3,1) = -2*y(2)*pari(1);
    r(3,2) = -2*y(1)*pari(1);
    r(4,1) = -2*pari(1)*y(1);
end


end

