function r = dfdxParIC(xin, InfDS, i,t, isStart)
%This should return df/dx', i.e., f goes down the row, x goes across
%columns
y = xin;


if size(y,2) > 1
r = zeros(InfDS.Nx,InfDS.Nx,size(y,2));
else
r = zeros(InfDS.Nx,InfDS.Nx);
end
omega = InfDS.omega;




%%%%%%%
%%%%%%%
pari = zeros(InfDS.Ntheta, size(y,2));
if ~isempty(i)
Hi = InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:);
pari(1) = y(3)*Hi(1,1)+y(4)*Hi(1,2)+y(5)*Hi(1,3);
pari(2) = y(6)*Hi(2,4);  
pari(3) = y(7)*Hi(3,5);
else
rowNum = 1:size(InfDS.H,1);
aa1 = kron(InfDS.H(mod(rowNum,InfDS.Ntheta)==1,:)',ones(1,InfDS.N));
aa2 = kron(InfDS.H(mod(rowNum,InfDS.Ntheta)==2,:)',ones(1,InfDS.N));
aa3 = kron(InfDS.H(mod(rowNum,InfDS.Ntheta)==0,:)',ones(1,InfDS.N));


%aa = kron(InfDS.H',ones(1,InfDS.N));

aa1(1,:) = y(3,:).*aa1(1,:);
aa1(2,:) = y(4,:).*aa1(2,:);
aa1(3,:) = y(5,:).*aa1(3,:);
pari(1,:) = sum(aa1(1:3,:),1); 
pari(2,:) = y(6,:).*aa2(4,:);
pari(3,:) = y(7,:).*aa3(5,:);   
end


b = zeros(size(pari));
if (InfDS.Nb > 0)
if ~isempty(i) %Only for one subject, but may have t > 1
b(1:InfDS.Ntheta,:) = kron(ones(1,size(y,2)),InfDS.Z*reshape(InfDS.b(i,:),InfDS.Nb,1),t);    
elseif mod(size(y,2),InfDS.Nsubj)==0 %for more than one subject but one t
b = InfDS.Z*InfDS.b';    
else %for more than one subject and more than one t
   bb = InfDS.Z*InfDS.b';    
   bb = kron(bb,ones(1,max(InfDS.allT)));
   b = bb(:,InfDS.Tfilter==1);        
end
end


pari = pari+b;
%%%%%


%df/dx'

if size(y,2) > 1
%df1/dy1
%df2/dy1-y6
    if isStart==1
    r(3,3,:) = 1; 
    r(4,4,:) = 1;
    r(5,5,:) = 1;
    r(1,6,:) = 1;
    r(2,7,:) = 1;
    r(6,6,:) = 1;
    r(7,7,:) = 1;
    else
    r(1,2,:) = 1;    
    r(2,1,:) = -omega-2*y(1,:).*pari(1,:).*y(2,:);
    r(2,2,:) = pari(1,:) - pari(1,:).*y(1,:).^2;
    r(2,3,:) = y(2,:) - y(1,:).^2.*y(2,:);    
    r(2,4,:) = reshape(kron(InfDS.U1(:,1),ones(1,InfDS.N)),1,size(y,2)).*y(2,:) - reshape(kron(InfDS.U1(:,1),ones(1,InfDS.N)),1,size(y,2)).*y(1,:).^2.*y(2,:);
    r(2,5,:) = reshape(kron(InfDS.U1(:,2),ones(1,InfDS.N)),1,size(y,2)).*y(2,:) - reshape(kron(InfDS.U1(:,2),ones(1,InfDS.N)),1,size(y,2)).*y(1,:).^2.*y(2,:);

    end
else
    if isStart==1
    r(3,3) = 1; 
    r(4,4) = 1;
    r(5,5) = 1;
    r(1,6) = 1;
    r(2,7) = 1;
    r(6,6) = 1;
    r(7,7) = 1;
    else
    r(1,2) = 1;    
    r(2,1) = -omega-2*y(1)*pari(1)*y(2);
    r(2,2) = pari(1) - pari(1)*y(1)^2;
    r(2,3) = y(2) - y(1)^2*y(2);
    r(2,4) = InfDS.U1(i,1)*y(2) - InfDS.U1(i,1)*y(1)^2*y(2);
    r(2,5) = InfDS.U1(i,2)*y(2) - InfDS.U1(i,2)*y(1)^2*y(2);   

    end
end


end
